                                                                                  {         01.10.03
E:\Source\Comps\TestDhCheckFolder20.pas

The program do test the component DhCheckFolder12.
( on the fly )                                                                                     }


unit TestDhCheckFolder10;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, BasicUnit,
  DhCheckFolder12, CommCtrl, Menus, ShellApi, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Men1: TMenuItem;
    mnuCreateList: TMenuItem;
    mnuCancel: TMenuItem;
    StatusBar1: TStatusBar;
    mnuSaveCheckes: TMenuItem;
    mnuLoadCheckesFromDisk: TMenuItem;
    Tools1: TMenuItem;
    Reset1: TMenuItem;
    mnuShowDirectory: TMenuItem;
    Splitter1: TSplitter;
    mnuCountFoldesChecked: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure mnuCreateListClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnuSaveCheckesClick(Sender: TObject);
    procedure mnuLoadCheckesFromDiskClick(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure mnuShowDirectoryClick(Sender: TObject);
    procedure mnuCountFoldesCheckedClick(Sender: TObject);
    procedure StatusBar1Resize(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    DhCheckFolder1 : TDhCheckFolder;
    ListBox1 : tListBox;
    procedure CreateComponent;
    procedure CreateListBox;
    procedure DhCheckFolder1ChangeFolder ( path : string );
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}



var
  DriveList : tStringList;
  CurDir : string;


procedure TForm1.mnuSaveCheckesClick(Sender: TObject);
begin
  SaveDialog1.InitialDir := CurDir;
  SaveDialog1.DefaultExt := 'dce';
  SaveDialog1.Filter := 'DhCheckExplorer-Selection (*.dce)|*.dce';
  if SaveDialog1.Execute then
   DhCheckFolder1.SaveChecksToDisk ( SaveDialog1.FileName );
end;


procedure TForm1.mnuLoadCheckesFromDiskClick(Sender: TObject);
var
  count : integer;
begin
  ListBox1.items.clear;
  OpenDialog1.InitialDir := CurDir;
  OpenDialog1.DefaultExt := 'dce';
  OpenDialog1.Filter := 'DriveSync-Selection (*.dce)|*.dce';
  if OpenDialog1.Execute then
   DhCheckFolder1.LoadChecksFromDisk ( OpenDialog1.FileName );
  count := DhCheckFolder1.CheckedFolderCount;
  StatusBar1.panels.items[1].text := ' Checked Folder(recursiv) = ' + IntToStr ( count );
end;


procedure TForm1.mnuCreateListClick(Sender: TObject);
var
  list : tStringList;
  summe : integer;

begin
  ListBox1.items.clear;
  ListBox1.refresh;
  screen.cursor := crHourGlass;
  list := DhCheckFolder1.CheckedFolderList;
  list.sort;
  ListBox1.items.AddStrings ( list );
  screen.cursor := crDefault;
  summe := ListBox1.items.count;
  StatusBar1.panels.items[1].text := ' SUM = ' + IntToStr ( summe );
end;


procedure tForm1.DhCheckFolder1ChangeFolder ( path : string );
Begin
  StatusBar1.panels.items[0].text := ' ' + path;
End;


procedure TForm1.FormCreate(Sender: TObject);
Begin
  CreateComponent;
  CreateListBox;
  DriveList := tStringList.create;
  CurDir := GetCurrentDir;
End;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  DriveList.free;
end;


procedure tForm1.CreateComponent;
Begin
  DhCheckFolder1 := TDhCheckFolder.create ( self );
  with DhCheckFolder1 do
   begin
    parent := form1;
    align := alLeft;
    width := form1.Width div 2;
    //CheckBoxes := false;
    //SetInitialDir ( 'C:\Windows' );
   end;
   DhCheckFolder1.OnChangeFolder := DhCheckFolder1ChangeFolder;
End;


procedure tForm1.CreateListBox;
Begin
  ListBox1 := tListBox.create ( self );
  with ListBox1 do
   begin
    parent := form1;
    align := alClient;
    color := clBtnFace;
    //align := alRight;
   end;
End;


procedure TForm1.Reset1Click(Sender: TObject);
begin
  DhCheckFolder1.ClearAllChecks;
  StatusBar1.panels.items[1].text := ' ';
  ListBox1.items.clear;
end;


procedure TForm1.mnuShowDirectoryClick(Sender: TObject);
begin
  //DhCheckFolder1.SetInitialDir ('\\Slave\Win XP (C)' );
  DhCheckFolder1.SetInitialDir ('C:\Windows' );
end;


procedure TForm1.mnuCountFoldesCheckedClick(Sender: TObject);
var
  count : integer;
begin
  count := DhCheckFolder1.CheckedFolderCount;
  StatusBar1.panels.items[1].text := ' Folder checked: ' + IntToStr(count);
end;


procedure TForm1.StatusBar1Resize(Sender: TObject);
begin
  StatusBar1.panels[0].width := round(form1.width * 0.71);
end;



END.
