                                                                                  {         01.10.03
E:\Source\Comps\TestDhCheckFolder10.pas

The program do test the component DhCheckFolder11.
(add component on form)                                                                            }

{ if you add the component on Form you must do in the Object-Inspector:
   1. Click Align of DhCheckFolder to left.
   2. Click Align of Splitter to left
   3. Click Align ListBox to client                                    }


unit TestDhCheckFolder10;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, BasicUnit,
  CommCtrl, Menus, ShellApi, StdCtrls, DhCheckFolder12, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Men1: TMenuItem;
    mnuCreateList: TMenuItem;
    mnuCancel: TMenuItem;
    StatusBar1: TStatusBar;
    mnuSaveCheckes: TMenuItem;
    mnuLoadCheckesFromDisk: TMenuItem;
    N1: TMenuItem;
    Tools1: TMenuItem;
    Reset1: TMenuItem;
    mnuShowDirectory: TMenuItem;
    Splitter1: TSplitter;
    ListBox1: TListBox;
    mnuCountFolderChecked: TMenuItem;
    DhCheckFolder1: TDhCheckFolder;
    procedure FormCreate(Sender: TObject);
    procedure mnuCreateListClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnuSaveCheckesClick(Sender: TObject);
    procedure mnuLoadCheckesFromDiskClick(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure mnuShowDirectoryClick(Sender: TObject);
    procedure DhCheckFolder1ChangeFolder(path: String);
    procedure mnuCountFolderCheckedClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}


const
  BACKUP_FILE = 'BackupSet.dat';
var
  DriveList : tStringList;
  CurDir : string;


procedure TForm1.mnuSaveCheckesClick(Sender: TObject);
begin
  DhCheckFolder1.SaveChecksToDisk ( CurDir + '\' + BACKUP_FILE )
end;


procedure TForm1.mnuLoadCheckesFromDiskClick(Sender: TObject);
var
  count : integer;
begin
  ListBox1.items.clear;
  if not FileExists ( CurDir + '\' + BACKUP_FILE ) then
   exit;
  DhCheckFolder1.LoadChecksFromDisk ( CurDir + '\' + BACKUP_FILE );
  count := DhCheckFolder1.CheckedFolderCount;
  //ListBox1.items.LoadFromFile ( BACKUP_FILE );
  StatusBar1.panels.items[1].text := ' Checked Folder(recursiv) = ' + IntToStr ( count );
end;


procedure TForm1.mnuCreateListClick(Sender: TObject);
var
  list : tStringList;
  summe : integer;

begin
  ListBox1.items.clear;
  ListBox1.refresh;
  screen.cursor := crHourGlass;
  list := DhCheckFolder1.CheckedFolderList;
  list.sort;
  ListBox1.items.AddStrings ( list );
  screen.cursor := crDefault;
  summe := ListBox1.items.count;
  StatusBar1.panels.items[1].text := ' SUM = ' + IntToStr ( summe );
end;


procedure TForm1.DhCheckFolder1ChangeFolder(path: String);
begin
  StatusBar1.panels.items[0].text := ' ' + path;
end;


procedure TForm1.FormCreate(Sender: TObject);
Begin
  DriveList := tStringList.create;
  CurDir := GetCurrentDir;
End;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  DriveList.free;
end;


procedure TForm1.Reset1Click(Sender: TObject);
begin
  DhCheckFolder1.ClearAllChecks;
  StatusBar1.panels.items[1].text := ' ';
end;


procedure TForm1.mnuShowDirectoryClick(Sender: TObject);
begin
  //DhCheckFolder1.SetInitialDir ('\\server\C' );
  DhCheckFolder1.SetInitialDir ('C:\Windows' );
end;


procedure TForm1.mnuCountFolderCheckedClick(Sender: TObject);
var
  count : integer;
begin
  count := DhCheckFolder1.CheckedFolderCount;
  ListBox1.items.add ( IntToStr(count) );
end;



END.
